//GPIOx constant file
#ifndef HDL50001_GPIO_h
#define HDL50001_GPIO_h

#include "HDL51001_ccf.h"

typedef struct
{
  __IO uint32_t IN;
  __IO uint32_t OUT;
  __IO uint32_t DIR;
  __IO uint32_t MSK;
  __IO uint32_t POL;
  __IO uint32_t EDG;
  __IO uint32_t BPS;
  
} GPIO_TypeDef;

#define APB1PERIPH_BASE       (0xC0100000)
//GPIOA
#define GPIOA_BASE            (APB1PERIPH_BASE + 0x000F0000)
#define GPIOA                 ((GPIO_TypeDef *) GPIOA_BASE)
//GPIOB
#define GPIOB_BASE            (APB1PERIPH_BASE + 0x000F0100)
#define GPIOB                 ((GPIO_TypeDef *) GPIOB_BASE)
//GPIOC
#define GPIOC_BASE            (APB1PERIPH_BASE + 0x000F0200)
#define GPIOC                 ((GPIO_TypeDef *) GPIOC_BASE)
//GPIOD
#define GPIOD_BASE            (APB1PERIPH_BASE + 0x000F0300)
#define GPIOD                 ((GPIO_TypeDef *) GPIOD_BASE)

//gpio constant and macro




#endif










