// ERROR: Возможно аппаратная ошибка. 
// Процессор зависает если раскоментировать getl и setl РОНов
// в функциях portSAVE_CONTEXT и portRESTORE_CONTEXT

.alias SP 39	; stack pointer
.alias BP 38	; function frame base pointer
.alias SI 37	; source address
.alias DI 36	; destination address
.alias CX 35	; counter

.alias R0	0
.alias R1	1
.alias R2	2
.alias R3	3
.alias R4	4
.alias R5	5
.alias R6	6
.alias R7	7

.global portSAVE_CONTEXT
.global portRESTORE_CONTEXT
.global PRS

.alias pStack 12

.text

portSAVE_CONTEXT:

	jmp pSC_fin

	PXCTCB:= rdl pxCurrentTCB	// *pxCurrentTCB  это указатель!
	pxTopOfStack:= rdl @PXCTCB	// Указатель на стек
	setl #DI,@pxTopOfStack

complete

pSC_fin:

	rdl #SP
	jmp @1

	reg7 := getl #R7
	reg6 := getl #R6
	reg5 := getl #R5
	reg4 := getl #R4
	reg3 := getl #R3
	reg2 := getl #R2
	reg1 := getl #R1
	reg0 := getl #R0
	reta := rdl  master.isr.retaddr
	saveSP := rdl iSP
	saveBP := rdl iBP

	wrl @reg7,#DI, pStack
	wrl @reg6,#DI, pStack + 4
	wrl @reg5,#DI, pStack + 8
	wrl @reg4,#DI, pStack + 12
	wrl @reg3,#DI, pStack + 16
	wrl @reg2,#DI, pStack + 20
	wrl @reg1,#DI, pStack + 24
	wrl @reg0,#DI, pStack + 28
	// PVP	  #DI, pStack + 32
	wrl @reta,#DI, pStack + 36
	wrl @saveSP,#DI, pStack + 40
	wrl @saveBP,#DI, pStack + 44

complete

// плановое восстановление, с переходом в вызывающего.

portRESTORE_CONTEXT:

	jmp pRC_fin

	PXCTCB := rdl pxCurrentTCB		// *pxCurrentTCB по идее это указатель!
	pxTopOfStack := rdl @PXCTCB		// *pxTopofStack
	setl #DI, @pxTopOfStack

complete

pRC_fin:
	
	rdl #SP
	jmp @1

	reg7 := rdl #DI, pStack	
	reg6 := rdl #DI, pStack +  4
	reg5 :=	rdl #DI, pStack +  8
	reg4 :=	rdl #DI, pStack +  12
	reg3 :=	rdl #DI, pStack +  16
	reg2 :=	rdl #DI, pStack +  20
	reg1 :=	rdl #DI, pStack +  24
	reg0:=	rdl #DI, pStack +  28
	//pvp :=	rdl #DI, pStack +  32
	pxCode := rdl #DI, pStack + 36
	loadSP := rdl #DI, pStack + 40
	loadBP := rdl #DI, pStack + 44
	
	setl #R7,@reg7
	setl #R6,@reg6
	setl #R5,@reg5
	setl #R4,@reg4
	setl #R3,@reg3
	setl #R2,@reg2
	setl #R1,@reg1
	setl #R0,@reg0
	wrl @loadSP, iSP
	wrl @loadBP, iBP
	wrl @pxCode, master.isr.retaddr	

complete


// первичное восстановление контекста с уходом на задачу.

PRS:

	jmp PRS_fin

	PXCTCB:= rdl pxCurrentTCB		// *pxCurrentTCB по идее это указатель!
	pxTopOfStack:= rdl @PXCTCB		// *pxTopofStack
	setl #DI, @pxTopOfStack

complete

PRS_fin:	

	reg7 := rdl #DI, pStack	
	reg6 := rdl #DI, pStack + 4
	reg5 :=	rdl #DI, pStack + 8
	reg4 :=	rdl #DI, pStack + 12
	reg3 :=	rdl #DI, pStack + 16
	reg2 :=	rdl #DI, pStack + 20
	reg1 :=	rdl #DI, pStack + 24
	reg0:=	rdl #DI, pStack + 28
	pvp :=	rdl #DI, pStack + 32
	pxCode := rdl #DI, pStack + 36

	taskSP := rdl #DI, pStack + 40
	taskBP := rdl #DI, pStack + 44
	saveSP := getl #SP
	saveBP := getl #BP
	

	setl #R7,@reg7
	setl #R6,@reg6
	setl #R5,@reg5
	setl #R4,@reg4
	setl #R3,@reg3
	setl #R2,@reg2
	setl #R1,@reg1
	setl #R0,@reg0

	wrl @saveSP, gSP
	wrl @saveBP, gBP

	setl #SP, @taskSP
	setl #BP, @taskBP

	jmp @pxCode
	
complete





